--- HUD ---

local vileBar10 = get_texture_info("vile_bar_10")
local vileBar9 = get_texture_info("vile_bar_9")
local vileBar8 = get_texture_info("vile_bar_8")
local vileBar7 = get_texture_info("vile_bar_7")
local vileBar6 = get_texture_info("vile_bar_6")
local vileBar5 = get_texture_info("vile_bar_5")
local vileBar4 = get_texture_info("vile_bar_4")
local vileBar3 = get_texture_info("vile_bar_3")
local vileBar2 = get_texture_info("vile_bar_2")
local vileBar1 = get_texture_info("vile_bar_1")
local vileBar0 = get_texture_info("vile_bar_0")
local gaeaBarFull = get_texture_info("gaea_bar_full")
local gaeaBarNofull = get_texture_info("gaea_bar_nofull")
local gaeaBarGray = get_texture_info("gaea_bar_gray")

--- VILE METER ---

vile_meter_render = function()
    local m = gMarioStates[0]
    local s = gPlayerSyncTable[m.playerIndex]

    local x = 4
    local y = 2

    if (s.vile_meter >= 10) then
        djui_hud_render_texture(vileBar10, x + 1, y + 1, 1, 1)
    elseif (s.vile_meter < 1) then
        djui_hud_render_texture(vileBar0, x + 1, y + 1, 1, 1)
    elseif (s.vile_meter < 2) then
        djui_hud_render_texture(vileBar1, x + 1, y + 1, 1, 1)
    elseif (s.vile_meter < 3) then
        djui_hud_render_texture(vileBar2, x + 1, y + 1, 1, 1)
    elseif (s.vile_meter < 4) then
        djui_hud_render_texture(vileBar3, x + 1, y + 1, 1, 1)
    elseif (s.vile_meter < 5) then
        djui_hud_render_texture(vileBar4, x + 1, y + 1, 1, 1)
    elseif (s.vile_meter < 6) then
        djui_hud_render_texture(vileBar5, x + 1, y + 1, 1, 1)
    elseif (s.vile_meter < 7) then
        djui_hud_render_texture(vileBar6, x + 1, y + 1, 1, 1)
    elseif (s.vile_meter < 8) then
        djui_hud_render_texture(vileBar7, x + 1, y + 1, 1, 1)
    elseif (s.vile_meter < 9) then
        djui_hud_render_texture(vileBar8, x + 1, y + 1, 1, 1)
    elseif (s.vile_meter < 10) then
        djui_hud_render_texture(vileBar9, x + 1, y + 1, 1, 1)
    end
end

gaea_meter_render = function()
    local m = gMarioStates[0]
    local s = gPlayerSyncTable[m.playerIndex]

    local x = 1
    local y = 10

    if s.x_gaea_meter < 16 then
        djui_hud_render_texture(gaeaBarNofull, x, y, 1, 1)
    else
        djui_hud_render_texture(gaeaBarFull, x, y, 1, 1)
    end
    djui_hud_render_texture(gaeaBarGray, x + 10, y + 1, 1, 16 - s.x_gaea_meter)
end

function render_hud_mario_lives()
    local s = gPlayerSyncTable[0]
    local lifeIcon = x_hud_icon
    if (s.character == 'x') then
        if s.x_is_alia == 1 then
            lifeIcon = alia_hud_icon
        else
            if s.x_armor == 0 then
                lifeIcon = x_hud_icon
            elseif s.x_armor == 1 then
                lifeIcon = x_lightarmor_hud_icon
            elseif s.x_armor == 2 then
                lifeIcon = x_gigaarmor_hud_icon
            elseif s.x_armor == 4 then
                lifeIcon = x_gaeaarmor_hud_icon
            end
        end
    elseif (s.character == 'zero') then
        if s.zero_alt == 0 then
            lifeIcon = zero_hud_icon
        elseif s.zero_alt == 1 then
            lifeIcon = zero_bz_hud_icon
        end
    elseif (s.character == 'vile') then
        lifeIcon = vile_hud_icon
    end
    hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) & ~HUD_DISPLAY_FLAG_LIVES)

    local x = 22
    local y = 15 

    djui_hud_render_texture(lifeIcon, x, y, 1 / (lifeIcon.width * 0.0625), 1 / (lifeIcon.height * 0.0625)) -- Matches the CS for consistency
    djui_hud_print_text("@", x + 16, y, 1)
    djui_hud_print_text(tostring(hud_get_value(HUD_DISPLAY_LIVES)):gsub("-", "M"), x + 32, y, 1)
end